//::///////////////////////////////////////////////
//:: Dye Kit - Item = Chest
//:: dye_itemchest.nss
//:: Copyright (c) 2003 Jake E. Fitch
//:://////////////////////////////////////////////
/*
    Set the item to be died to the chest slot.
*/
//:://////////////////////////////////////////////
//:: Created By: Jake E. Fitch (Milambus Mandragon)
//:: Created On: Dec. 9, 2004
//:://////////////////////////////////////////////

string ClothColor(int iColor);
string MetalColor(int iColor);

void main()
{
    object oPC = GetPCSpeaker();

    SetLocalInt(oPC, "ItemToDye", INVENTORY_SLOT_CLOAK);

    object oItem = GetItemInSlot(INVENTORY_SLOT_CLOAK, oPC);

    if (GetIsObjectValid(oItem)) {
        int iLeather1 = GetItemAppearance(oItem, ITEM_APPR_TYPE_ARMOR_COLOR, ITEM_APPR_ARMOR_COLOR_LEATHER1);
        int iLeather2 = GetItemAppearance(oItem, ITEM_APPR_TYPE_ARMOR_COLOR, ITEM_APPR_ARMOR_COLOR_LEATHER2);
        int iCloth1 = GetItemAppearance(oItem, ITEM_APPR_TYPE_ARMOR_COLOR, ITEM_APPR_ARMOR_COLOR_CLOTH1);
        int iCloth2 = GetItemAppearance(oItem, ITEM_APPR_TYPE_ARMOR_COLOR, ITEM_APPR_ARMOR_COLOR_CLOTH2);
        int iMetal1 = GetItemAppearance(oItem, ITEM_APPR_TYPE_ARMOR_COLOR, ITEM_APPR_ARMOR_COLOR_METAL1);
        int iMetal2 = GetItemAppearance(oItem, ITEM_APPR_TYPE_ARMOR_COLOR, ITEM_APPR_ARMOR_COLOR_METAL2);

        string sOutput = "Leather 1: " + ClothColor(iLeather1);
        sOutput += "\n" + "Leather 2: " + ClothColor(iLeather2);
        sOutput += "\n" + "Cloth 1: " + ClothColor(iCloth1);
        sOutput += "\n" + "Cloth 2: " + ClothColor(iCloth2);
        sOutput += "\n" + "Metal 1: " + MetalColor(iMetal1);
        sOutput += "\n" + "Metal 2: " + MetalColor(iMetal2);

        SendMessageToPC(oPC, sOutput);
    }
}

string ClothColor(int iColor) {
    switch (iColor) {
        case 00: return "Lightest Tan/Brown";
        case 01: return "Light Tan/Brown";
        case 02: return "Dark Tan/Brown";
        case 03: return "Darkest Tan/Brown";

        case 04: return "Lightest Tan/Red";
        case 05: return "Light Tan/Red";
        case 06: return "Dark Tan/Red";
        case 07: return "Darkest Tan/Red";

        case 08: return "Lightest Tan/Yellow";
        case 09: return "Light Tan/Yellow";
        case 10: return "Dark Tan/Yellow";
        case 11: return "Darkest Tan/Yellow";

        case 12: return "Lightest Tan/Grey";
        case 13: return "Light Tan/Grey";
        case 14: return "Dark Tan/Grey";
        case 15: return "Darkest Tan/Grey";

        case 16: return "Lightest Olive";
        case 17: return "Light Olive";
        case 18: return "Dark Olive";
        case 19: return "Darkest Olive";

        case 20: return "White";
        case 21: return "Light Grey";
        case 22: return "Dark Grey";
        case 23: return "Charcoal";

        case 24: return "Light Blue";
        case 25: return "Dark Blue";

        case 26: return "Light Aqua";
        case 27: return "Dark Aqua";

        case 28: return "Light Teal";
        case 29: return "Dark Teal";

        case 30: return "Light Green";
        case 31: return "Dark Green";

        case 32: return "Light Yellow";
        case 33: return "Dark Yellow";

        case 34: return "Light Orange";
        case 35: return "Dark Orange";

        case 36: return "Light Red";
        case 37: return "Dark Red";

        case 38: return "Light Pink";
        case 39: return "Dark Pink";

        case 40: return "Light Purple";
        case 41: return "Dark Purple";

        case 42: return "Light Violet";
        case 43: return "Dark Violet";

        case 44: return "Shiny White";
        case 45: return "Shiny Black";

        case 46: return "Shiny Blue";
        case 47: return "Shiny Aqua";

        case 48: return "Shiny Teal";
        case 49: return "Shiny Green";

        case 50: return "Shiny Yellow";
        case 51: return "Shiny Orange";

        case 52: return "Shiny Red";
        case 53: return "Shiny Pink";

        case 54: return "Shiny Purple";
        case 55: return "Shiny Violet";

        case 56: return "Hidden: Silver";
        case 57: return "Hidden: Obsidian";
        case 58: return "Hidden: Gold";
        case 59: return "Hidden: Copper";
        case 60: return "Hidden: Grey";
        case 61: return "Hidden: Mirror";
        case 62: return "Hidden: Pure White";
        case 63: return "Hidden: Pure Black";

        case 64: return "Metallic Mauve";
        case 65: return "Greyed Metallic Mauve";
        case 66: return "Metallic Gold";
        case 67: return "Greyed Metallic Gold";
        case 68: return "Metallic Green";
        case 69: return "Greyed Metallic Green";
        case 70: return "Metallic Indigo";
        case 71: return "Greyed Metallic Indigo";

        case 72: return "Metallic Violet";
        case 73: return "Greyed Metallic Violet";
        case 74: return "Metallic Brown";
        case 75: return "Greyed Metallic Brown";
        case 76: return "Metallic Teal";
        case 77: return "Greyed Metallic Teal";
        case 78: return "Metallic Blue";
        case 79: return "Greyed Metallic Blue";

        case 80: return "Metallic Olive";
        case 81: return "Greyed Metallic Olive";
        case 82: return "Metallic Aqua";
        case 83: return "Greyed Metallic Aqua";
        case 84: return "Greyed Metallic Fern Green";
        case 85: return "Metallic Marshland";
        case 86: return "Greyed Metallic Marshland";
        case 87: return "Metallic Fern Green";

        case 88: return "Lightest Metallic Red";
        case 89: return "Light Metallic Red";
        case 90: return "Metallic Red";
        case 91: return "Dark Metallic Red";
        case 92: return "Lightest Metallic Yellow";
        case 93: return "Light Metallic Yellow";
        case 94: return "Metallic Yellow";
        case 95: return "Dark Metallic Yellow";

        case 96: return "Lightest Mauve";
        case 97: return "Light Mauve";
        case 98: return "Mauve";
        case 99: return "Dark Mauve";
        case 100: return "Lightest Sangria";
        case 101: return "Light Sangria";
        case 102: return "Sangria";
        case 103: return "Dark Sangria";

        case 104: return "Lightest Forest Green";
        case 105: return "Light Forest Green";
        case 106: return "Forest Green";
        case 107: return "Dark Forest Green";
        case 108: return "Lightest Clover";
        case 109: return "Light Clover";
        case 110: return "Clover";
        case 111: return "Dark Clover";

        case 112: return "Lightest Marshland";
        case 113: return "Light Marshland";
        case 114: return "Marshland";
        case 115: return "Dark Marshland";
        case 116: return "Lighest Sienna";
        case 117: return "Light Sienna";
        case 118: return "Sienna";
        case 119: return "Dark Sienna";

        case 120: return "Lightest Acorn";
        case 121: return "Light Acorn";
        case 122: return "Acorn";
        case 123: return "Dark Acorn";
        case 124: return "Lightest Gondola";
        case 125: return "Light Gondola";
        case 126: return "Gondola";
        case 127: return "Dark Gondola";

        case 128: return "Lightest Ash Brown";
        case 129: return "Light Ash Brown";
        case 130: return "Ash Brown";
        case 131: return "Dark Ash Brown";
        case 132: return "Lightest Mirage";
        case 133: return "Light Mirage";
        case 134: return "Mirage";
        case 135: return "Dark Mirage";

        case 136: return "Lightest Midnight Blue";
        case 137: return "Light Midnight Blue";
        case 138: return "Midnight Blue";
        case 139: return "Dark Midnight Blue";
        case 140: return "Lightest Dull Teal";
        case 141: return "Light Dull Teal";
        case 142: return "Dull Teal";
        case 143: return "Dark Dull Teal";

        case 144: return "Lightest Magenta";
        case 145: return "Light Magenta";
        case 146: return "Magenta";
        case 147: return "Dark Magenta";
        case 148: return "Light Sky Blue";
        case 149: return "Sky Blue";
        case 150: return "Light Mosque";
        case 151: return "Mosque";

        case 152: return "Light Sap Green";
        case 153: return "Sap Green";
        case 154: return "Light Buttered Rum";
        case 155: return "Buttered Rum";
        case 156: return "Light Burnt Sienna";
        case 157: return "Burnt Sienna";
        case 158: return "Light Cherrywood";
        case 159: return "Cherrywood";

        case 160: return "Light Blackberry";
        case 161: return "Blackberry";
        case 162: return "Firebrick";
        case 163: return "Flirt";
        case 164: return "Pale Sky";
        case 165: return "Raincloud";
        case 166: return "Snow";
        case 167: return "Pine Tree";

        case 168: return "Light Black Bean";
        case 169: return "Black Bean";
        case 170: return "Valentino";
        case 171: return "Ebony Clay";
        case 172: return "Black Forest";
        case 173: return "Dark Cedar";
        case 174: return "Wood Brown";
        case 175: return "Speckled Gold";
    }

    return "";
}

string MetalColor(int iColor) {
    switch (iColor) {
        case 00: return "Lightest Shiny Silver";
        case 01: return "Light Shiny Silver";
        case 02: return "Dark Shiny Obsidian";
        case 03: return "Darkest Shiny Obsidian";

        case 04: return "Lightest Dull Silver";
        case 05: return "Light Dull Silver";
        case 06: return "Dark Dull Obsidian";
        case 07: return "Darkest Dull Obsidian";

        case 08: return "Lightest Gold";
        case 09: return "Light Gold";
        case 10: return "Dark Gold";
        case 11: return "Darkest Gold";

        case 12: return "Lightest Celestial Gold";
        case 13: return "Light Celestial Gold";
        case 14: return "Dark Celestial Gold";
        case 15: return "Darkest Celestial Gold";

        case 16: return "Lightest Copper";
        case 17: return "Light Copper";
        case 18: return "Dark Copper";
        case 19: return "Darkest Copper";

        case 20: return "Lightest Brass";
        case 21: return "Light Brass";
        case 22: return "Dark Brass";
        case 23: return "Darkest Brass";

        case 24: return "Light Red";
        case 25: return "Dark Red";
        case 26: return "Light Dull Red";
        case 27: return "Dark Dull Red";

        case 28: return "Light Purple";
        case 29: return "Dark Purple";
        case 30: return "Light Dull Purple";
        case 31: return "Dark Dull Purple";

        case 32: return "Light Blue";
        case 33: return "Dark Blue";
        case 34: return "Light Dull Blue";
        case 35: return "Dark Dull Blue";

        case 36: return "Light Teal";
        case 37: return "Dark Teal";
        case 38: return "Light Dull Teal";
        case 39: return "Dark Dull Teal";

        case 40: return "Light Green";
        case 41: return "Dark Green";
        case 42: return "Light Dull Green";
        case 43: return "Dark Dull Green";

        case 44: return "Light Olive";
        case 45: return "Dark Olive";
        case 46: return "Light Dull Olive";
        case 47: return "Dark Dull Olive";

        case 48: return "Light Prismatic";
        case 49: return "Dark Prismatic";

        case 50: return "Lightest Rust";
        case 51: return "Light Rust";
        case 52: return "Dark Rust";
        case 53: return "Darkest Rust";

        case 54: return "Light Aged Metal";
        case 55: return "Dark Aged Metal";

        case 56: return "Hidden: Silver";
        case 57: return "Hidden: Obsidian";
        case 58: return "Hidden: Gold";
        case 59: return "Hidden: Copper";
        case 60: return "Hidden: Grey";
        case 61: return "Hidden: Mirror";
        case 62: return "Hidden: Pure White";
        case 63: return "Hidden: Pure Black";

        case 64: return "Shiny Mauve";
        case 65: return "Greyed Shiny Mauve";
        case 66: return "Shiny Gold";
        case 67: return "Greyed Shiny Gold";
        case 68: return "Shiny Green";
        case 69: return "Greyed Shiny Green";
        case 70: return "Shiny Indigo";
        case 71: return "Greyed Shiny Indigo";

        case 72: return "Shiny Violet";
        case 73: return "Greyed Shiny Violet";
        case 74: return "Shiny Brown";
        case 75: return "Greyed Shiny Brown";
        case 76: return "Shiny Teal";
        case 77: return "Greyed Shiny Teal";
        case 78: return "Shiny Blue";
        case 79: return "Greyed Shiny Blue";

        case 80: return "Shiny Olive";
        case 81: return "Greyed Shiny Olive";
        case 82: return "Shiny Aqua";
        case 83: return "Greyed Shiny Aqua";
        case 84: return "Greyed Shiny Fern Green";
        case 85: return "Shiny Marshland";
        case 86: return "Greyed Shiny Marshland";
        case 87: return "Shiny Fern Green";

        case 88: return "Lightest Shiny Red";
        case 89: return "Light Shiny Red";
        case 90: return "Shiny Red";
        case 91: return "Dark Shiny Red";
        case 92: return "Lightest Shiny Yellow";
        case 93: return "Light Shiny Yellow";
        case 94: return "Shiny Yellow";
        case 95: return "Dark Shiny Yellow";

        case 96: return "Lightest Mauve";
        case 97: return "Light Mauve";
        case 98: return "Mauve";
        case 99: return "Dark Mauve";
        case 100: return "Lightest Sangria";
        case 101: return "Light Sangria";
        case 102: return "Sangria";
        case 103: return "Dark Sangria";

        case 104: return "Lightest Forest Green";
        case 105: return "Light Forest Green";
        case 106: return "Forest Green";
        case 107: return "Dark Forest Green";
        case 108: return "Lightest Clover";
        case 109: return "Light Clover";
        case 110: return "Clover";
        case 111: return "Dark Clover";

        case 112: return "Lightest Marshland";
        case 113: return "Light Marshland";
        case 114: return "Marshland";
        case 115: return "Dark Marshland";
        case 116: return "Lighest Sienna";
        case 117: return "Light Sienna";
        case 118: return "Sienna";
        case 119: return "Dark Sienna";

        case 120: return "Lightest Acorn";
        case 121: return "Light Acorn";
        case 122: return "Acorn";
        case 123: return "Dark Acorn";
        case 124: return "Lightest Gondola";
        case 125: return "Light Gondola";
        case 126: return "Gondola";
        case 127: return "Dark Gondola";

        case 128: return "Lightest Ash Brown";
        case 129: return "Light Ash Brown";
        case 130: return "Ash Brown";
        case 131: return "Dark Ash Brown";
        case 132: return "Lightest Mirage";
        case 133: return "Light Mirage";
        case 134: return "Mirage";
        case 135: return "Dark Mirage";

        case 136: return "Lightest Midnight Blue";
        case 137: return "Light Midnight Blue";
        case 138: return "Midnight Blue";
        case 139: return "Dark Midnight Blue";
        case 140: return "Lightest Dull Teal";
        case 141: return "Light Dull Teal";
        case 142: return "Dull Teal";
        case 143: return "Dark Dull Teal";

        case 144: return "Lightest Magenta";
        case 145: return "Light Magenta";
        case 146: return "Magenta";
        case 147: return "Dark Magenta";
        case 148: return "Light Sky Blue";
        case 149: return "Sky Blue";
        case 150: return "Light Mosque";
        case 151: return "Mosque";

        case 152: return "Light Sap Green";
        case 153: return "Sap Green";
        case 154: return "Light Buttered Rum";
        case 155: return "Buttered Rum";
        case 156: return "Light Burnt Sienna";
        case 157: return "Burnt Sienna";
        case 158: return "Light Cherrywood";
        case 159: return "Cherrywood";

        case 160: return "Light Blackberry";
        case 161: return "Blackberry";
        case 162: return "Firebrick";
        case 163: return "Flirt";
        case 164: return "Pale Sky";
        case 165: return "Raincloud";
        case 166: return "Snow";
        case 167: return "Pine Tree";

        case 168: return "Light Black Bean";
        case 169: return "Black Bean";
        case 170: return "Valentino";
        case 171: return "Ebony Clay";
        case 172: return "Black Forest";
        case 173: return "Dark Cedar";
        case 174: return "Wood Brown";
        case 175: return "Speckled Gold";
    }

    return "";
}
