//::///////////////////////////////////////////////
//:: Scarface's Crafting System V1.0
//:: sfcs__consts
//::
//:://////////////////////////////////////////////
/*
     All of the constants required for this
     crafting system.
*/
//////////////////////////////////////////////////

//:: Constants

// Set the maximum total amount of properties allowed per item
// ONLY set this between 1 - 8
const int MAX_ITEM_PROPERTIES = 8;

// Set the maximum Enhancement Bonus allowed on weapons
// Do NOT set this to less than 1 or more than 20
// ONLY set this between 1 - 20
const int MAX_ENHANCEMENT_BONUS = 20;

// Set the maximum Attack Bonus allowed on weapons
// ONLY set this between 1 - 20
const int MAX_ATTACK_BONUS = 20;

// Set the maximum Damage Bonus allowed on weapons
// ONLY set this between 1 - 10
const int MAX_DAMAGE_BONUS = 10;

// Set the maximum Ability Bonus allowed on items
// ONLY set this between 1 - 12
const int MAX_ABILITY_BONUS = 12;

// Set the maximum AC Bonus allowed on items
// ONLY set this between 1 - 12
const int MAX_AC_BONUS = 12;

// Set the maximum Regeneration Bonus allowed on items
// ONLY set this between 1 - 20
const int MAX_REGEN_BONUS = 10;

// Set if you want to display the level required for the
// item being crafted - This is only really useful if your
// server has Item Level Restricion enabled
// TRUE = Display ILR    :    FALSE = Dont display ILR
const int ITEM_LEVEL_DISPLAY = TRUE;

// Set cost multiplier
// This will be multiplied by the value of the item
// Example: If the normal cost was 100 gold and the multiplier was left at 1.0,
// That would calculate 1.0 = 1 x 100 = 100. If the Multiplier was set to 0.5 it
// would give 50% of the normal cost value 0.5 = 1/2 x 100 = 50. If the
// multiplier was set to 2.0 then it would double the cost. 2.0 = 2 x 100 = 200.
// Do NOT set this to less than 0.1
// Default 5.0 (5 x normal cost)
const float COST_MULTIPLIER = 5.0;
